
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <process.h>
#include <ctype.h>
#include <dos.h>

#define FALSE  0
#define TRUE   1
#define OFFSET(fp)  ((unsigned)(fp))
#define SEGMENT(fp) ((unsigned)((unsigned long)(fp) >> 16))

#define FAR_POINTER(seg,ofs) ((void far *) \
                 (((unsigned long)(seg) << 16) | (unsigned)(ofs)))

void    get_program_name(void);
void    add_to_table(void);

struct  MCB
        {
        char          flag;
        unsigned int  owner;
        unsigned int  paragraphs;
        };

struct  DD_HEADER
        {
        struct DD_HEADER far *next;
        unsigned int     attribute;
        unsigned int     strategy_entry_point;
        unsigned int     interrupt_entry_point;
        unsigned char    name[8];
        };

struct  PSP
        {
        unsigned int    psp_int20;
        unsigned int    top_mem;
        unsigned char   reserved1;
        unsigned char   dos_long_call [5];
        void            far *psp_int22;
        void            far *psp_int23;
        void            far *psp_int24;
        unsigned int    parent_seg;
        unsigned char   fh_table[20];
        unsigned int    env_seg;
        void            far *stack_save_addr;
        unsigned int    fh_count;
        unsigned char   far *fh_table_addr;
        unsigned char   reserved2 [29];
        unsigned char   fcb_1 [16];
        unsigned char   fcb_2 [16];
        unsigned char   reserved3 [11];
        unsigned char   command_len;
        unsigned char   command_string [127];
        };

struct  MEMORY_ITEM
        {
        char            name[15];
        unsigned long   size;
        };

struct  MEMORY_ITEM  memory_item[100];

unsigned int        far *temp_ptr;
unsigned char       far *env_ptr;
struct  PSP         far *psp_ptr;
struct  MCB         far *mcb_ptr;
struct  DD_HEADER   far *dd_ptr;

struct  MCB         mcb;
struct  DD_HEADER   device_driver;

unsigned int        n;
unsigned int        EMM_present;
unsigned int        UMBs_present;
unsigned int        first_time = TRUE;
unsigned int        column;
unsigned int        DOS_seg;
unsigned int        dd_ofs;
unsigned int        mcb_seg;
unsigned int        env_seg;

unsigned long       size_this_mcb;
unsigned long       total_conventional;
unsigned long       free_conventional;
unsigned long       total_expanded;
unsigned long       free_expanded;
unsigned long       amount_in_use;
unsigned long       non_DOS_memory;

unsigned char       byte1;
unsigned char       byte2;
char                string1[101];
char                program_name[101];
unsigned int        ourpsp;

union    REGS       regs;
struct   SREGS      sregs;

void    main(int argc, char *argv[])
        {
        regs.x.ax = 0x5100;
        int86x(0x21, &regs, &regs, &sregs);
        ourpsp = regs.x.bx;

        regs.x.ax = 0x5200;
        int86x(0x21, &regs, &regs, &sregs);

        DOS_seg = sregs.es;
        dd_ofs  = regs.x.bx + 0x22;
        dd_ptr  = FAR_POINTER(DOS_seg, dd_ofs);

        n       = regs.x.bx - 0x02;
        temp_ptr= FAR_POINTER(DOS_seg, n);
        mcb_seg = *temp_ptr;
        mcb_ptr = FAR_POINTER(mcb_seg, 0);

        while (OFFSET(dd_ptr) != 0xffff)
            {
            device_driver = *dd_ptr;
            if ( (device_driver.attribute & 0x8000) == 0x8000
                && strncmp(device_driver.name, "EMMXXXX0", 8) == 0 )
                    EMM_present = TRUE;
            dd_ptr = dd_ptr->next;
            }
        dd_ptr  = FAR_POINTER(DOS_seg, dd_ofs);



        if (argc == 1)
            goto show_resident_programs;


show_device_drivers:

        printf(
"                            Device Drivers\n");
        printf(
"--------       --------       --------       --------       --------\n");

        column = 0;
        while (OFFSET(dd_ptr) != 0xffff)
            {
            device_driver = *dd_ptr;

            memset(string1, 0, 20);
            if ( (device_driver.attribute & 0x8000) == 0x8000)
                memcpy(string1, device_driver.name, 8);
            else
                sprintf(string1, "(%u units)", 
                    (unsigned int) device_driver.name[0]);

            printf("%-12.12s   ", string1);
            if (++column % 5 == 0)
                printf("\n");
            dd_ptr = dd_ptr->next;
            }
        if (column % 5 != 0)
            printf("\n");


show_resident_programs:
        int86x(0x12, &regs, &regs, &sregs);
        total_conventional = (unsigned long) regs.x.ax * 1024l;

        free_conventional = 0l;

/******************************************************************
*       printf("%-20.20s   %4.4s    %4.4s   %8.8s    %4.4s\n",
*           "Program", "MCB", "PSP", "Size", "Env");
******************************************************************/

        mcb = *mcb_ptr;
        while (mcb.flag == 'M' || mcb.flag == 'Z')
            {
            size_this_mcb = mcb.paragraphs * 16l;
            psp_ptr   = FAR_POINTER(mcb.owner, 0x0000);
            env_ptr   = FAR_POINTER(psp_ptr->env_seg, 0x0000);
            get_program_name();

/******************************************************************
*           printf("%-20.20s   %4.4X    %4.4X   %8ld   %4.4X\n",
*               program_name, mcb_seg, mcb.owner,
*               (long) mcb.paragraphs * 16l, psp_ptr->env_seg);
******************************************************************/

            if (mcb_seg > 0x9FF0)
                UMBs_present = TRUE;
            else
            if (ourpsp == mcb.owner && mcb_seg != psp_ptr->env_seg - 1)
                free_conventional += size_this_mcb;
            else
            if ( mcb.flag == 'Z' 
              && (mcb.owner == 0x0000 || mcb.owner == 0xffff) )
                free_conventional += size_this_mcb;
            else
                add_to_table();

            mcb_seg = SEGMENT(mcb_ptr) + mcb.paragraphs + 1;
            mcb_ptr = FAR_POINTER(mcb_seg, 0);
            mcb = *mcb_ptr;
            }

        free_conventional += 16l;
        amount_in_use = total_conventional - free_conventional;
        memory_item[0].size = amount_in_use - non_DOS_memory;

        printf("\n");
        printf("   Memory control blocks, by name\n");
        printf("   ------------------------------ \n");

        for (n=0; n<100; n++)
            {
            if (memory_item[n].name[0] == '\0')
                break;
            printf("      %-12.12s %6lu\n", 
                memory_item[n].name, memory_item[n].size);
            }

        printf("                 --------\n");
        printf("     %7lu    - %7lu    = %7lu (%luk) free\n\n", 
                    total_conventional,
                    amount_in_use,
                    free_conventional,
                    free_conventional / 1024l);

        if (EMM_present)
            {
            regs.h.ah = 0x42;
            int86x(0x67, &regs, &regs, &sregs);
            if (regs.h.ah == 0)
                printf("total expanded: %7luk   free expanded: %7luk\n",
                            (long) regs.x.dx * 16l, 
                            (long) regs.x.bx * 16l);
            }

        if (UMBs_present)
            printf("Upper memory blocks exist.\n");

        exit(0);
        }

void    add_to_table(void)
        {
        int i;

        if (strcmp(program_name, "DOS") != 0)
            non_DOS_memory += size_this_mcb;

        for (i=0; i<100; i++)
            {
            if (strcmp(memory_item[i].name, program_name) == 0)
                {
                memory_item[i].size += size_this_mcb;
                return;
                }
            if (memory_item[i].name[0] == '\0')
                {
                strcpy(memory_item[i].name, program_name);
                memory_item[i].size = size_this_mcb;
                return;
                }
            }
        }

void    get_program_name(void)
        {
        if (first_time)
            {
            first_time = FALSE;
            strcpy(program_name, "DOS");
            return;
            }

        if (psp_ptr->parent_seg == mcb.owner)
            {
            strcpy(program_name, "DOS");
            return;
            }

        if (mcb.owner == 0x0000 || mcb.owner == 0xffff)
            {
            if (mcb.flag == 'Z')
                strcpy(program_name, "<free>");
            else
                strcpy(program_name, "<trapped>");
            return;
            }

        if (mcb.owner == 0x0008)
            {
            strcpy(program_name, "DOS");
            return;
            }

        if (ourpsp == mcb.owner)
            {
            if (mcb_seg == psp_ptr->env_seg - 1)
                strcpy(program_name, "Environment");
            else
                strcpy(program_name, "<free>");
            return;
            }

        if (_osmajor < 3)
            {
            strcpy(program_name, "Unknown");
            return;
            }

        memset(program_name, 0, 100);

        while (1)
            {
            while (*env_ptr++ != 0)
                ;
            if (*env_ptr++ != 0)
                continue;
            if (*env_ptr++ != 1)
                return;
            if (*env_ptr++ != 0)
                return;
            n = 0;
            while (*env_ptr != 0 && *env_ptr != '.')
                {
                program_name[n] = *env_ptr++;
                if (program_name[n] == ':' || program_name[n] == '\\')
                    {
                    n = 0;
                    memset(program_name, 0, 100);
                    }
                else
                    {
                    n++;
                    }
                }
            strlwr(program_name);
            program_name[0] = (char) toupper(program_name[0]);
            return;
            }
        }

